SuperStrict

' required modules
Framework MaxGUI.Drivers
Import BRL.EventQueue
Import Holzchopf.MaxGuiLayout

' create top level layout
Local lmWindow:TMaxGuiLayout = TMaxGuiLayout.Create(0,0,200,0)
' and let that one appear as window
lmWindow.Window("Example 1", 0,0,Null, WINDOW_TITLEBAR | WINDOW_CENTER | WINDOW_RESIZABLE)
' add a new line with a text field in a panel fitting the text field
lmWindow.AddBottom(0)
lmWindow.sub[0,0].Panel("Title",, PANEL_GROUP)
lmWindow.sub[0,0].SetMargin(2,2)
lmWindow.sub[0,0].Inner(0,20).TextField()
lmWindow.sub[0,0].FitToContents()
' add a line with a text area in a panel
lmWindow.AddBottom(0)
lmWindow.sub[0,1].Panel("Description",, PANEL_GROUP)
lmWindow.sub[0,1].SetMargin(2,2)
lmWindow.sub[0,1].Inner(0,80).TextArea()
lmWindow.sub[0,1].FitToContents()
' add a line with two buttons
lmWindow.AddBottom(0)
lmWindow.sub[0,2].Split([80,0,80],[25],true)
lmWindow.sub[0,2].sub[0,0].Button("OK",, BUTTON_OK)
lmWindow.sub[0,2].sub[2,0].Button("Cancel",, BUTTON_CANCEL)
lmWindow.sub[0,2].FitToContents()
' make the window to fit all gadgets
lmWindow.FitToContents()
' lock the layout so the second row (0 = first, 1 = second) will scale upon window size change
lmWindow.LockLayout(0,1)
' lock the button's layout so the free layout between them will scale upon window size change
lmWindow.sub[0,2].LockLayout(1,0)

' main loop
Repeat
	WaitEvent()
	Print CurrentEvent.ToString()
	' typical event handling
	Select EventID()
	Case EVENT_WINDOWCLOSE
		End
	End Select
Forever
