SuperStrict

' required modules
Framework MaxGUI.Drivers
Import MaxGUI.ProxyGadgets
Import BRL.EventQueue
Import Holzchopf.MaxGuiLayout

' create top level layout
Local lmWindow:TMaxGuiLayout = TMaxGuiLayout.Create(0,0,400,300)
' and let that one appear as window
lmWindow.Window("Example 3", 0,0,Null, WINDOW_TITLEBAR | WINDOW_CENTER | WINDOW_RESIZABLE)
' split into two pieces
lmWindow.Split([250,0],[0])
' in the left one: create text area, of which the edges are aligned to the window
Local taTest:TGadget = lmWindow.sub[0,0].TextArea(, TEXTAREA_READONLY)
' in the right one: create a set of controls
Local lmControls:TMaxGuiLayout = lmWindow.sub[1,0]

' split the controls layout into two pieces
lmControls.Split([0],[20,0],True)
' in the top one: create a label, a read-only text area and a stepper-slider
lmControls.sub[0,0].Split([70,0,18],[0],true)
lmControls.sub[0,0].sub[0,0].Label("# of buttons:")
Local taCount:TGadget = lmControls.sub[0,0].sub[1,0].TextArea(, TEXTAREA_READONLY)
Local slCount:TGadget = lmControls.sub[0,0].sub[2,0].Slider(, SLIDER_STEPPER)
' in the lower one: a proxy gadget
Local scpControls:TScrollPanel = TScrollPanel(lmControls.sub[0,1]._Gadget(..
  CreateScrollPanel,,, lmControls.gadget, SCROLLPANEL_SUNKEN | SCROLLPANEL_VALWAYS | SCROLLPANEL_HSCALING))
lmWindow.LockLayout(0)

' create a New layout manager For some buttons
Local lmButtons:TMaxGuiLayout = TMaxGuiLayout.Create(0,0, ScrollPanelClient(scpControls).ClientWidth(), 400, 0,0)
lmButtons.SetGadget(ScrollPanelClient(scpControls))
lmButtons.Split([0],[0])
lmButtons.sub[0,0].SetMargin(5,5)
lmButtons.sub[0,0].Panel()
' this function fills that layout with a bunch of push-buttons
FillWithButtons(lmButtons.sub[0,0], scpControls, 10)

' set some initial values
taCount.SetText("10")
SetSliderRange(slCount, 1, 30)
SetSliderValue(slCount, 10)


' main loop
Repeat
	WaitEvent()
	' put events into text area (except textarea-events)
	If EventSource() <> taTest
		AddTextAreaText(taTest, CurrentEvent.ToString()+"~n")
	EndIf
	' typical event handling
	Select EventID()
	Case EVENT_WINDOWCLOSE
		End
	Case EVENT_GADGETACTION
		Select EventSource()
		Case slCount
			Local cnt:Int = EventData()
			FillWithButtons(lmButtons.sub[0,0], scpControls, cnt)
			taCount.SetText(cnt)
		End Select
	End Select
Forever

' fill a layout with a specified number of push buttons and set the respective slider value
Function FillWithButtons(pLayout:TMaxGuiLayout, pPanel:TScrollPanel, pCnt:Int)
	Local ln:Int = pLayout.sub.length
	' nothing changed
	If pCnt = ln
		Return
	' add some buttons
	ElseIf pCnt > ln
		pLayout.AddBottom(25, pCnt-ln)
		For Local a:Int = ln Until pCnt
			pLayout.sub[0,a].Button("Button "+(a+1))
		Next
	' remove some buttons
	Else
		pLayout.RemoveBottom(ln-pCnt)
	EndIf
	' resize the layout to it's childs
	pLayout.FitToContents()
	pPanel.FitToChildren()
End Function

